#include <shop>

#if SOURCEMOD_V_MINOR < 10 
---> #error This plugin only compile on SM 1.10
#endif

int BP, BSP, BD;
bool BS[MAXPLAYERS+1];

public Plugin myinfo ={
	name = "[Shop] ExoJumpBoots",
	description = "Boots for high jumps",
	author = "-=HellFire=-",
	version = "1.0",
	url = "VK: vk.com/insellx | HLMOD: hlmod.ru/members/hellfire.105029"
};

public void OnPluginStart()
{
    ConVar hCvar;

    HookConVarChange((hCvar = CreateConVar("sm_shop_boots_price", "5000", "Цена покупки ботинок")), BootsPrice);
    BP = hCvar.IntValue;

    HookConVarChange((hCvar = CreateConVar("sm_shop_boots_sellprice", "2500", "Цена продажи ботинок")), BootsSellPrice);
    BSP = hCvar.IntValue;

    HookConVarChange((hCvar = CreateConVar("sm_shop_boots_duration", "604800", "Длительность ботинок в секундах (по умолчанию 1 неделя)")), BootsDuration);
    BD = hCvar.IntValue;

    CloseHandle(hCvar);

    AutoExecConfig(true, "shop_exojumpboots", "shop");

    HookEvent("player_spawn", PlayerSpawn);
  
    if(Shop_IsStarted()) Shop_Started();

    if(GetEngineVersion() != Engine_CSGO){
        SetFailState("This plugin only for CS:GO");
    }
}

public void OnClientDisconnect(int client)
{
	BS[client] = false;
}

public void OnPluginEnd()
{
    Shop_UnregisterMe();
}

public void Shop_Started()
{
    CategoryId CATEGORY = Shop_RegisterCategory("Эхо ботинки", "Эхо Ботинки", "");

    if(CATEGORY == INVALID_CATEGORY)
    {
        SetFailState("Failed to register category");
    }

    if(Shop_StartItem(CATEGORY, "boots"))
    {
        Shop_SetInfo("Эхо ботинки", "Позволяют высоко прыгать", BP, BSP, Item_Togglable, BD);
        Shop_SetCallbacks(_, OnEquipItem);
        Shop_EndItem();
    }
    else 
    {
        SetFailState("Failed to register item");
    }
}

public int BootsPrice(ConVar hCvar, const char[] szOldValue, const char[] szNewValue)
{
    BP = hCvar.IntValue;
}

public int BootsSellPrice(ConVar hCvar, const char[] szOldValue, const char[] szNewValue)
{
    BSP = hCvar.IntValue;
}

public int BootsDuration(ConVar hCvar, const char[] szOldValue, const char[] szNewValue)
{
    BD = hCvar.IntValue;
}

public ShopAction OnEquipItem(int client, CategoryId category_id, const char[] CATEGORY, ItemId item_id, const char[] item, bool isOn, bool elapsed)
{
 	if (isOn || elapsed)
	{
        OnClientDisconnect(client);
        return Shop_UseOff;
	}
        BS[client] = true;
        SetBoots(client);

        return Shop_UseOn;
}

public PlayerSpawn(Handle event, const char[] name, bool dontBroadcast)
{
	int client = GetClientOfUserId(GetEventInt(event, "userid"));

        if (!BS[client]) return;
        {
            SetBoots(client);
        }
}

public SetBoots(client)
{
    if (BS[client])
    {
        SetEntProp(client, Prop_Send, "m_passiveItems", 1, 1, 1);
    }
}